﻿Module Module1

    Private Structure EmployeeRecord
        Dim EmpName As String
        Dim DeptNbr As Integer
        Dim JobTitle As String
        Dim HireDate As Date
        Dim HrlyRate As Single
    End Structure

    Private maudtEmpRecord() As EmployeeRecord

    Public Sub Main()

        Dim strEmpFileName As String
        Dim intEmpFileNbr As Integer

        Dim intArrX As Integer

        strEmpFileName = My.Application.Info.DirectoryPath & "\EMPLOYEE.DAT"
        intEmpFileNbr = FreeFile()

        FileOpen(intEmpFileNbr, strEmpFileName, OpenMode.Input)

        intArrX = -1

        Do Until EOF(intEmpFileNbr)
            intArrX += 1
            ReDim Preserve maudtEmpRecord(intArrX)
            With maudtEmpRecord(intArrX)
                Input(intEmpFileNbr, .EmpName)
                Input(intEmpFileNbr, .DeptNbr)
                Input(intEmpFileNbr, .JobTitle)
                Input(intEmpFileNbr, .HireDate)
                Input(intEmpFileNbr, .HrlyRate)
            End With
        Loop

        FileClose(intEmpFileNbr)

        PrintEmps(maudtEmpRecord)

        Console.WriteLine()
        Console.WriteLine("Press Enter to close this window.")
        Console.ReadLine()

    End Sub

    Private Sub PrintEmps(ByVal paudtEmps() As EmployeeRecord)

        Dim intX As Integer

        For intX = 0 To UBound(paudtEmps)
            With maudtEmpRecord(intX)
                Console.WriteLine(.EmpName.PadRight(20) _
                                & .DeptNbr.ToString.PadRight(6) _
                                & .JobTitle.PadRight(20) _
                                & Format(.HireDate, "MM/dd/yyyy").PadRight(12) _
                                & Format(.HrlyRate, "Standard"))
            End With
        Next

    End Sub

End Module